from pgu import engine, gui, timer
import pygame
from pygame.locals import *
import hollow

class TextLine:
    def __init__(self, text, offset, font="data/Jorvik_.TTF", size=36, color=(1,1,1)):
        font = pygame.font.Font(font, size)
        text += " "
        print "rendering", text
        self.surface = hollow.textOutline(font, text, color, (150,150,150))
        print"done text"
        self.offset = -offset
        
    def blit(self, screen, offset):
        x = screen.get_width()/2-self.surface.get_width()/2
        
        screen.blit(self.surface, (x,screen.get_height()-(self.offset+offset)))
        
class TextScroller(engine.State):
    sound_file = ""
    background = ""
    text = ""
    color = (1,1,1)
    def __init__(self, game, next_state, *args):
        engine.State.__init__(self, game)
        self.next_state = next_state
        self.args = args
        self.quit = 0
        
    def init(self):
        self.sound = pygame.mixer.Sound(self.sound_file)
        self.sound.play(-1)
        self.image = pygame.transform.scale(pygame.image.load(self.background).convert(), (800,600))
        self.lines = [ TextLine(line, i*40, color=self.color) for i, line in enumerate(self.text.split("\n")) ]
        self.start_time = pygame.time.get_ticks()
        
    def paint(self,s): 
        #s.fill((0,0,255))
        s.blit(self.image,(0,0))
        
    def update(self,screen):
        self.paint(screen)
        for line in self.lines:
            line.blit(screen, (pygame.time.get_ticks()-self.start_time)/40 )
        pygame.display.flip() #better to do updates
        
    def event(self, evt):
        if evt.type is QUIT: self.quit = 1
        if evt.type is KEYDOWN: self.quit = 1
        if evt.type is MOUSEBUTTONUP: self.quit = 1
                

    def loop(self):
        if self.quit:
            self.sound.stop()
            print "DOING NEXT STATE"
            return self.next_state(self.game, *self.args)
    
